<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: emini/checkiterationemini.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_087401d2fcfe0d344c8cee8acbcc7f48.html">emini</a>
  </div>
</div>
<div class="contents">
<h1>checkiterationemini.c</h1><a href="checkiterationemini_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: checkiterationemini.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="emini_8h.html">emini.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">static</span> <span class="keywordtype">int</span>       condinp_equil;
<a name="l00034"></a>00034 <span class="keyword">static</span> PetscReal condinp_j;
<a name="l00035"></a>00035 <span class="keyword">static</span> PetscReal condinp_equil_j;
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="checkiterationemini_8c.html#ae5edbe0fe0c81314aff57f7ab636f66b">00037</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationemini_8c.html#ae5edbe0fe0c81314aff57f7ab636f66b">CheckIterationEmini_Init</a>()
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   PetscTruth flg;
<a name="l00042"></a>00042   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-condinp_equil&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;condinp_equil,&amp;flg);CHKERRQ(ierr);
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00044"></a>00044     condinp_equil=1;
<a name="l00045"></a>00045     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00046"></a>00046       <span class="stringliteral">&quot;Option -condinp_equil not found, using default value: %i\n&quot;</span>,
<a name="l00047"></a>00047       condinp_equil
<a name="l00048"></a>00048     );
<a name="l00049"></a>00049   }
<a name="l00050"></a>00050   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-condinp_j&quot;</span>,&amp;condinp_j,&amp;flg);CHKERRQ(ierr);
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00052"></a>00052     condinp_j=0.1;
<a name="l00053"></a>00053     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00054"></a>00054       <span class="stringliteral">&quot;Option -condinp_j not found, using default value: %g\n&quot;</span>,
<a name="l00055"></a>00055       condinp_j
<a name="l00056"></a>00056     );
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-condinp_equil_j&quot;</span>,&amp;condinp_equil_j,&amp;flg);CHKERRQ(ierr);
<a name="l00059"></a>00059   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00060"></a>00060     condinp_equil_j=0.0;
<a name="l00061"></a>00061     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00062"></a>00062       <span class="stringliteral">&quot;Option -condinp_equil_j not found, using default value: %g\n&quot;</span>,
<a name="l00063"></a>00063       condinp_equil_j
<a name="l00064"></a>00064     );
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">00071</a> <span class="keywordtype">int</span> <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="keyword">static</span> PetscReal condinp_last_j=PETSC_MIN;
<a name="l00074"></a>00074   <span class="keyword">static</span> PetscReal condinp_last_equil_j=PETSC_MIN;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">/* initialize if necessary */</span>
<a name="l00079"></a>00079   <span class="keywordflow">if</span> (doinit) {
<a name="l00080"></a>00080     ierr = <a class="code" href="checkiterationemini_8c.html#ae5edbe0fe0c81314aff57f7ab636f66b">CheckIterationEmini_Init</a>();CHKERRQ(ierr);
<a name="l00081"></a>00081     doinit=0;
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/* check if we should save complete set of output data */</span>
<a name="l00085"></a>00085   PetscReal valMpHext;
<a name="l00086"></a>00086   ierr = <a class="code" href="field_8h.html#aacac4af746c003dbd608d662ca2272e2">MpHext</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;valMpHext);CHKERRQ(ierr);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">/* check if a set of output data should be written */</span>
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (PetscAbsReal(valMpHext-condinp_last_j) &gt; condinp_j) {
<a name="l00090"></a>00090     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00091"></a>00091     condinp_last_j=valMpHext;
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (condinp_equil==1 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00094"></a>00094     <span class="comment">/* check for condinp_equil_j (defaults to 0.0) */</span>
<a name="l00095"></a>00095     <span class="keywordflow">if</span> (PetscAbsReal(valMpHext-condinp_last_equil_j) &gt; condinp_equil_j) {
<a name="l00096"></a>00096       gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00097"></a>00097       condinp_last_j=valMpHext;
<a name="l00098"></a>00098       condinp_last_equil_j=valMpHext;
<a name="l00099"></a>00099     }
<a name="l00100"></a>00100   }
<a name="l00101"></a>00101   <span class="keywordflow">else</span> {
<a name="l00102"></a>00102     <span class="comment">/* write checkpoint file even if we are not in equilibrium */</span>
<a name="l00103"></a>00103     <span class="keywordtype">int</span>  oldinp;
<a name="l00104"></a>00104     oldinp=gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>;
<a name="l00105"></a>00105     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=9999;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00108"></a>00108       <span class="stringliteral">&quot;Writing checkpoint file (9999) at: %g ns\n&quot;</span>,
<a name="l00109"></a>00109       gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9
<a name="l00110"></a>00110     );
<a name="l00111"></a>00111     ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=oldinp;
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="comment">/* write output data */</span>
<a name="l00117"></a>00117   ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00118"></a>00118   ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">/* if system is in equilibrium */</span>
<a name="l00121"></a>00121   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="comment">/* update external field */</span>
<a name="l00124"></a>00124     ierr = <a class="code" href="field_8h.html#a386ce6c3aee542bfbdfbc8bce99d51fe">Hext_ho_hstep</a>(gdata);CHKERRQ(ierr);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="comment">/* increase (pseudo-)time by 1 ns */</span>
<a name="l00127"></a>00127     gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a> += 1e-9/gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>;
<a name="l00128"></a>00128   }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">/* exit if field did not get updated and we are</span>
<a name="l00131"></a>00131 <span class="comment">     therefore still in equilibrium</span>
<a name="l00132"></a>00132 <span class="comment">  */</span>
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>&gt;0) {
<a name="l00134"></a>00134     gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>=99;
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

